"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.isScalarType = isScalarType;
exports.isEnumType = isEnumType;
exports.isDefined = isDefined;
exports.assertNever = assertNever;
exports.toCamelCase = toCamelCase;
function isScalarType(field) {
    return field["kind"] === "scalar";
}
function isEnumType(field) {
    return field["kind"] === "enum";
}
function isDefined(value) {
    return value !== undefined && value !== null;
}
function assertNever(value) {
    throw new Error(`Unhandled discriminated union member: ${JSON.stringify(value)}`);
}
function toCamelCase(name) {
    return name.substring(0, 1).toLowerCase() + name.substring(1);
}
