"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.transformDMMF = transformDMMF;
var _helpers = require("./helpers");
var _jsonSchema = require("./jsonSchema");
var _model = require("./model");
const isObject = (obj)=>Boolean(obj && typeof obj === "object" && !Array.isArray(obj));
// @TODO-DP: not time for proper typing of this now, sorry
/* eslint-disable @typescript-eslint/no-unsafe-assignment */ /* eslint-disable @typescript-eslint/no-unsafe-argument */ /* eslint-disable @typescript-eslint/no-unsafe-member-access */ /* eslint-disable @typescript-eslint/no-unsafe-call */ const expandRefs = (definitions, obj)=>{
    if (!isObject(obj)) {
        return;
    }
    Object.keys(obj).forEach((key)=>{
        if (Array.isArray(obj[key])) {
            obj[key].forEach((item, index)=>{
                if (isObject(item) && item.$ref) {
                    obj[key][index] = definitions[item.$ref];
                } else {
                    expandRefs(definitions, item);
                }
            });
        } else if (isObject(obj[key])) {
            const ref = obj[key].$ref;
            if (ref) {
                obj[key] = definitions[ref];
            } else {
                expandRefs(definitions, obj[key]);
            }
        }
    });
};
/* eslint-enable @typescript-eslint/no-unsafe-assignment */ /* eslint-enable @typescript-eslint/no-unsafe-argument */ /* eslint-enable @typescript-eslint/no-unsafe-member-access */ /* eslint-enable @typescript-eslint/no-unsafe-call */ function getPropertyDefinition({ definitions  }) {
    return (model)=>{
        return [
            model.dbName || (0, _helpers).toCamelCase(model.name),
            definitions === null || definitions === void 0 ? void 0 : definitions[model.name], 
        ];
    };
}
function transformDMMF(dmmf) {
    // TODO: Remove default values as soon as prisma version < 3.10.0 doesn't have to be supported anymore
    const { models =[] , enums =[] , types =[]  } = dmmf.datamodel;
    const initialJSON = (0, _jsonSchema).getInitialJSON();
    const modelDefinitionsMap = models.map((0, _model).getJSONSchemaModel({
        enums
    }));
    const typeDefinitionsMap = types.map((0, _model).getJSONSchemaModel({
        enums
    }));
    const definitions = Object.fromEntries([
        ...modelDefinitionsMap,
        ...typeDefinitionsMap, 
    ]);
    expandRefs(definitions, definitions);
    const modelPropertyDefinitionsMap = models.map(getPropertyDefinition({
        definitions
    }));
    const properties = Object.fromEntries(modelPropertyDefinitionsMap);
    return {
        ...initialJSON,
        properties
    };
}
