"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.attributeExtractor = void 0;
const attributeExtractor = (schema)=>{
    const lines = schema.split("\n");
    return lines.flatMap((line)=>{
        const attributes = [];
        if (line.includes("@map(")) {
            const result = line.match(/@map\("(\w+)"\)/);
            if (result === null || result === void 0 ? void 0 : result[1]) {
                attributes.push(`@map("${result[1]}")`);
            }
        }
        if (line.includes("@db.ObjectId")) {
            attributes.push("@db.ObjectId");
        }
        if (attributes.length) {
            var ref;
            const indentation = ((ref = line.match(/^(\s*)/)) === null || ref === void 0 ? void 0 : ref[1]) || "";
            return [
                `${indentation}/// ${attributes.join(" ")}`,
                line
            ];
        }
        return line;
    }).join("\n");
};
exports.attributeExtractor = attributeExtractor;
