"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getConfig = void 0;
var _path = _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
const getConfig = ()=>{
    const prismaSchemaFile = process.env.PRISMA_SCHEMA_FILE || "prisma/schema.prisma";
    const prismaSchemaPath = _path.default.dirname(prismaSchemaFile);
    const prismaSchemaFilename = _path.default.basename(prismaSchemaFile);
    const prismaSchemaPathResolved = prismaSchemaPath.charAt(0) === "/" ? prismaSchemaPath : _path.default.join(process.cwd(), prismaSchemaPath);
    const originalPrismaSchemaPath = _path.default.join(prismaSchemaPathResolved, prismaSchemaFilename);
    const processedPrismaSchemaPath = _path.default.join(prismaSchemaPathResolved, "processed-schema.prisma");
    const jsonSchemaPath = _path.default.join(prismaSchemaPathResolved, "json-schema.json");
    const mongoUri = process.env.MONGO_URI;
    if (!mongoUri) {
        throw new Error("MONGO_URI env var must be set!");
    }
    return {
        originalPrismaSchemaPath,
        processedPrismaSchemaPath,
        jsonSchemaPath,
        mongoUri
    };
};
exports.getConfig = getConfig;
