"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.processSchema = void 0;
var _attributeExtractor = require("./attributeExtractor");
var _prependGenerator = require("./prependGenerator");
var _fs = require("fs");
var _getConfig = require("./getConfig");
const getSchema = async ()=>{
    const { originalPrismaSchemaPath  } = (0, _getConfig).getConfig();
    return String(await _fs.promises.readFile(originalPrismaSchemaPath));
};
const writeSchema = async (schema)=>{
    const { processedPrismaSchemaPath  } = (0, _getConfig).getConfig();
    await _fs.promises.writeFile(processedPrismaSchemaPath, schema);
};
const processSchema = async ()=>writeSchema((0, _prependGenerator).prependGenerator((0, _attributeExtractor).attributeExtractor(await getSchema())));
exports.processSchema = processSchema;
