"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.verifyMongoSchema = void 0;
var _mongodb = require("mongodb");
var _getConfig = require("./getConfig");
const verifyMongoSchema = async (schema)=>{
    const { mongoUri , mongoDb  } = (0, _getConfig).getConfig();
    const client = new _mongodb.MongoClient(mongoUri);
    try {
        await client.connect();
        const database = client.db(mongoDb);
        await Promise.all(Object.keys(schema.properties).map(async (collectionName)=>{
            try {
                const firstFailedDocument = await database.collection(collectionName).findOne({
                    $nor: [
                        {
                            $jsonSchema: schema.properties[collectionName]
                        }, 
                    ]
                });
                if (firstFailedDocument) {
                    console.info(`❌ Collection ${collectionName} failed validation, first failed document is: `, firstFailedDocument);
                } else {
                    console.info(`✅ Collection ${collectionName} passed validation`);
                }
            } catch (e) {
                console.error(e, collectionName);
            }
        }));
    } finally{
        await client.close();
    }
};
exports.verifyMongoSchema = verifyMongoSchema;
